//here should be the new versions of functions we get called with our hooks

#include "plugin.h"

#define CLIENT_COMMAND_DEFINITIONS
#include "complexmacros.h"
#undef CLIENT_COMMAND_DEFINITIONS

#include <sdk_util.h> //useful almost everywhere
#include <cbase.h>

#define MASK_DIGESTING 4194304


int Spawn(edict_t *pEntity) {
	if(FStrEq(STRING(pEntity->v.classname), "worldspawn")) //worldspawn means that everything is just starting up
	{
		//this is the only place you can precache new things, so do it here

		srand( (unsigned)(gpGlobals->time) );
		DynamicSizedData.Initialize();
		RETURN_META_VALUE(MRES_HANDLED, 0);
	}

	RETURN_META_VALUE(MRES_IGNORED, 0);
}

void PlayerPostThink( edict_t *pEntity ) {
	if( pEntity->v.team == 1 /*&& ((!(pEntity->v.iuser4 & MASK_DIGESTING)) || (cvar_marineredeem_blockdigest->value == 0))*/ ) //player is a marine that isn't being digested
	{
		int iPlayerIndex = ENTINDEX( pEntity );
		if( (pEntity->v.health < DynamicSizedData.fLastHealth[iPlayerIndex]) && (pEntity->v.health <= cvar_marineredeem_health->value) && (pEntity->v.health > 0) ) //player needs to try to redeem
		{
			char model[32];
			strcpy(model, (g_engfuncs.pfnInfoKeyValue((*g_engfuncs.pfnGetInfoKeyBuffer)(pEntity), "model")));

			if( FStrEq( model, "heavy" ) ) //player has a chance to redeem and is a heavy
			{
				if( (((float)(rand()%10000 + 1)) / 100.0f) <= cvar_marineredeem_chance->value ) //picks a random number between 0.01 and 100.00 , then compares the chances
				{
					//yey, they get redeemed
					
					int iActivatedGates = 0;
					CBaseEntity *pPhase = NULL;

					
					PhaseLL *pCurr;				

					//find active gates
					while( (pPhase = UTIL_FindEntityByString( pPhase, "classname" , "phasegate" )) != NULL )
					{
						pCurr = DynamicSizedData.pHead;
						while(pCurr != NULL)
						{
							if(pPhase->pev->origin == pCurr->vecPosition) {
								pCurr->bPassedTest = true;
								break;
							}
							pCurr = pCurr->next;
						}
						if( pCurr != NULL ) ++iActivatedGates;
					}

					//trim dead gates
					pCurr = DynamicSizedData.pHead;
					while(pCurr != NULL)
					{
						if(pCurr->bPassedTest == false )
						{
							PhaseLL *pTemp = pCurr;
							pCurr = pCurr->next;
							if(pTemp == DynamicSizedData.pHead) DynamicSizedData.pHead = pCurr;
							else {
								PhaseLL *pUpdate = DynamicSizedData.pHead;
								while( pUpdate->next != pTemp ) pUpdate = pUpdate->next;
								pUpdate->next = pUpdate->next->next;
							}
							delete pTemp;
						}
						else {
							pCurr->bPassedTest = false; //clear it for the next run
							pCurr = pCurr->next;
						}
					}

					if( iActivatedGates > 1 ) //2 or more activated gates means....they're all currently active :P
					{
						int iPickedGate = rand() % iActivatedGates;
						pCurr = DynamicSizedData.pHead;
						while(iPickedGate != 0)
						{
							pCurr = pCurr->next;
							--iPickedGate;
						}
						UTIL_NS_TeleportTo( pCurr->vecPosition + Vector(0,0,60), pEntity );
						/*if(pEntity->v.iuser4 & MASK_DIGESTING)
						{
							pEntity->v.iuser4 &= ~MASK_DIGESTING;
							pEntity->v.effects &= ~EF_NODRAW;
						}*/
					}
				}
			}
		}		
		DynamicSizedData.fLastHealth[iPlayerIndex] = pEntity->v.health; //to track getting hurt		
	}
	RETURN_META(MRES_IGNORED);
}

void EmitAmbientSound(edict_t *entity, float *pos, const char *samp, float vol, float attenuation, int fFlags, int pitch)
{
	if(samp[0] == 'm') //a sound under the misc folder
	{
		if( samp[5] == 'p' && samp[6] == 'h' && samp[7] == 'a' && samp[8] == 's' && samp[9] == 'e' && 
			samp[10] == 'g' && samp[11] == 'a' && samp[12] == 't' && samp[13] == 'e' )
		{
			//phasegate came online
			PhaseLL *pCurr;
			if( DynamicSizedData.pHead == NULL )
			{
				DynamicSizedData.pHead = new PhaseLL;
				pCurr = DynamicSizedData.pHead;
			}
			else
			{
				pCurr = DynamicSizedData.pHead;
				while(pCurr->next != NULL) pCurr = pCurr->next;
				pCurr->next = new PhaseLL;
				pCurr = pCurr->next;
			}
			pCurr->vecPosition = entity->v.origin;
		}
	}

	RETURN_META(MRES_IGNORED);
}
