//This file contains utility functions that don't serve any specific purpose but are invaluable nevertheless

#include "plugin.h"
#include <sdk_util.h>	//pre-defined function definitions saves us a lot of work
#include <cbase.h>
#include <player.h>

#define SERVER_COMMAND_DEFINITIONS
	#include "complexmacros.h"	
#undef SERVER_COMMAND_DEFINITIONS

#define CREATE_CVAR_VARIABLES
	#include "complexmacros.h"	
#undef CREATE_CVAR_VARIABLES

DynDataAutoCleanUp DynamicSizedData; //the global declaration of an instance of the dynamic sized data struct


//=================================================================
//the grand old initialization function
//=================================================================
void plugin_init(void) {
	UTIL_LogPrintf( "[" MY_LOGTAG "] ================LOADING===============\n");
	UTIL_LogPrintf( "[" MY_LOGTAG "] By " MY_AUTHOR " (" MY_EMAIL ")\n");
	UTIL_LogPrintf( "[" MY_LOGTAG "] Version: " MY_VERSION "\n");
	UTIL_LogPrintf( "[" MY_LOGTAG "] ================LOADING===============\n");

	#define REGISTERING_SERVER_COMMANDS
		#include "complexmacros.h"	
	#undef REGISTERING_SERVER_COMMANDS

	#define REGISTERING_CVARS
		#include "complexmacros.h"	
	#undef REGISTERING_CVARS

	DynamicSizedData.Initialize();

	//Automatically register a cvar that makes the plugin version publically available
	static cvar_t plugin_version_register = { MY_LOGTAG "_VERSION", MY_VERSION, FCVAR_SERVER | FCVAR_SPONLY | FCVAR_PRINTABLEONLY, 0 };
	CVAR_REGISTER( &plugin_version_register );
}


//=================================================================
//the grand old quit function
//=================================================================
void plugin_quit(void) {
	UTIL_LogPrintf( "[" MY_LOGTAG "] ===============UNLOADING==============\n");
	UTIL_LogPrintf( "[" MY_LOGTAG "] By " MY_AUTHOR " (" MY_EMAIL ")\n");
	UTIL_LogPrintf( "[" MY_LOGTAG "] Version: " MY_VERSION "\n");
	UTIL_LogPrintf( "[" MY_LOGTAG "] ===============UNLOADING==============\n");
}




