//this file exists so that you can paste functions that you need from util.cpp in the actual SDK
//as well as your new custom helper functions you declared in utilfunctions.h

//REMEMBER: to keep your DLL size down, remove functions you don't need from this file


#include "plugin.h"
#include <sdk_util.h>	//pre-defined function definitions saves us a lot of work
#include <cbase.h>

//decided to just fukkit and add all the headers that show up in the hlsdk util.cpp
#include <gamerules.h>
#include <saverestore.h>
#include <time.h>
#include <shake.h>
#include <decals.h>
#include <player.h>
//#include <weapons.h>

DLL_GLOBAL const Vector     g_vecZero = Vector(0,0,0);









//=========================================================
// UTIL_LogPrintf - Prints a logged message to console.
// Preceded by LOG: ( timestamp ) < message >
//=========================================================
void UTIL_LogPrintf( char *fmt, ... )
{
	va_list			argptr;
	static char		string[1024];
	
	va_start ( argptr, fmt );
	vsprintf ( string, fmt, argptr );
	va_end   ( argptr );

	// Print to server console
	ALERT( at_logged, "%s", string );
}

// returns a CBaseEntity pointer to a player by index.  Only returns if the player is spawned and connected
// otherwise returns NULL
// Index is 1 based
CBaseEntity	*UTIL_PlayerByIndex( int playerIndex )
{
	CBaseEntity *pPlayer = NULL;

	if ( playerIndex > 0 && playerIndex <= gpGlobals->maxClients )
	{
		edict_t *pPlayerEdict = INDEXENT( playerIndex );
		if ( pPlayerEdict && !pPlayerEdict->free )
		{
			pPlayer = CBaseEntity::Instance( pPlayerEdict );	
		}
	}
	
	return pPlayer;
}

void UTIL_NS_TeleportTo( Vector vecSendTo, edict_t *pEntity )
{
	PLAYBACK_EVENT_FULL( 0, NULL, 40, 0, (float *)&pEntity->v.origin, (float *)&g_vecZero, 0.0, 0.0, 0, 0, 0, 0 ); 
	EMIT_SOUND_DYN2(pEntity, CHAN_STATIC, "misc/transport.wav", 1.0f, ATTN_NORM, 0, 100);

	pEntity->v.origin = vecSendTo;

	PLAYBACK_EVENT_FULL( 0, NULL, 40, 0, (float *)&pEntity->v.origin, (float *)&g_vecZero, 0.0, 0.0, 0, 0, 0, 0 ); 
	EMIT_SOUND_DYN2(pEntity, CHAN_STATIC, "misc/transport.wav", 1.0f, ATTN_NORM, 0, 100);
}

CBaseEntity *UTIL_FindEntityByString( CBaseEntity *pStartEntity, const char *szKeyword, const char *szValue )
{
	edict_t	*pentEntity;

	if (pStartEntity)
		pentEntity = pStartEntity->edict();
	else
		pentEntity = NULL;

	pentEntity = FIND_ENTITY_BY_STRING( pentEntity, szKeyword, szValue );

	if (!FNullEnt(pentEntity))
		return CBaseEntity::Instance(pentEntity);
	return NULL;
}


























unsigned short FixedUnsigned16( float value, float scale )
{
	int output;

	output = (int)(value * scale);
	if ( output < 0 )
		output = 0;
	if ( output > 0xFFFF )
		output = 0xFFFF;

	return (unsigned short)output;
}

short FixedSigned16( float value, float scale )
{
	int output;

	output = (int)(value * scale);

	if ( output > 32767 )
		output = 32767;

	if ( output < -32768 )
		output = -32768;

	return (short)output;
}





